#ifndef COMMON_H
#define COMMON_H

#ifdef _WIN32

#ifdef USE_SOCK
#include <winsock.h>
#endif//USE_SOCK

#include <windows.h>
#else//for Linux( incomplete )
#ifdef USE_SOCK
#include <socket.h>
#define SOCK int
#endif//USE_SOCK

#include <unistd.h>

#endif //WIN32

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <fcntl.h>
#include <ctype.h>
#include <errno.h>
#include <assert.h>
#include <cstdint>

#define _abs(expr) ((expr) > 0 ? (expr) : -(expr))

#define E_ABORT_IO -1
#define E_INVALID_IN -2
#define E_INVALID_PARAM -3

inline long long Q_pow(long base, long index);

#ifdef USING_NS_STD
using namespace std;
#endif
#ifdef USING_NS_YX
using namespace yx;
#endif

#include "console.h"
#include <time.h>

#define M_UC 0
#define M_C  1

#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) > (b)) ? (a) : (b))

#define LZR_SYMBOL "LZR"

#ifndef NDEBUG
#define debug(...) wprintf(L"[DEBUG] " __VA_ARGS__)
#else
#define debug(...)
#endif

struct LZRHD
{
	unsigned char symb[4];
	uint32_t flag_bits;
	uint32_t data_leng;
	uint32_t orig_leng;
};
#endif /*COMMON_H*/
